Bug 2037 - Use GeoClue as the positioning service
: Use GeoClue as the positioning service
Status: RESOLVED WONTFIX
Product: Location
General
: 5.0/(1.2009.42-11)
: All Windows
: Low enhancement with 5 votes (vote)
: ---
Assigned To: unassigned
: location-framework-bugs
: http://geoclue.freedesktop.org
:
:
:
  Show dependency tree
 
Reported: 2007-09-21 10:46 UTC by Henri Bergius
Modified: 2009-11-18 18:29 UTC (History)
5 users (show)

See Also:


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description Henri Bergius (reporter) 2007-09-21 10:46:42 UTC
Currently the Maemo platform provides a GPS library as the preferred
positioning API.

The problem with GPS is that it only works outdoors, which is not that common
usage situation for the Internet Tablets. Far more common is to use the tablet
indoors at home, in cafeteria, or in an office.

Even though navigational positioning is not usually necessary in those
situations, position data is still very useful. It can be used for little
things like displaying local weather in the weather applet and changing system
time zone automatically when traveling.

Other interesting options are communicating the location to various
applications like Google Maps-based services opened with a browser.

At the moment Maemo applications can know their position only when a bluetooth
GPS receiver is available, paired and has a fix (i.e. is outdoors). However,
there would be also other ways to get position: from WiFi connection using
services like Loki or Plazes, or from the IP address of the connection. While
these are not as accurate as GPS, they can still be used in a lot of scenarios.

GeoClue is a D-Bus service that abstracts the various positioning backends so
that application developers do not need to care whether GPS is available or
not, they just need to make a simple method call of "where am I?".

Inn addition to just plain coordinates, GeoClue also supports the concept of
"civic positioning", meaning that addresses, city names and such are also
available from the service, and can be geocoded back to coordinates.

GeoClue is already available and packaged for Maemo, with a simple UI:
http://www.flickr.com/photos/bergie/1183413084/

Some more reading:

http://www.slideshare.net/ajturner/geoclue-state-of-the-map-2007
http://vilunki.wordpress.com/
http://worrydream.com/MagicInk/#inferring_context_from_the_environment
Comment 1 Jake Kunnari 2007-09-25 18:25:57 UTC
Quim added to cc-field. Quim: Sounds like an enhancement request more than a
bug, what do you think?
Comment 2 Quim Gil nokia 2007-09-26 00:29:02 UTC
Doesn't belong to the developer platform, but to the location framework.
Comment 3 Jason Carter 2007-09-26 19:43:06 UTC
> GeoClue is already available and packaged for Maemo, with a simple UI

I believe it is currently broken and does not work on the latest firmware
release.
Comment 4 Jason Carter 2007-10-02 21:36:58 UTC
After reflashing with the firmware released today (38-6, I believe), it appears
to be working again. Hmm.
Comment 5 Quim Gil nokia 2007-10-03 06:26:32 UTC
Perhaps you had something messed by extra software installed? The new release
only fixes the SDHC issue, all the rest is just the same.
Comment 6 SEWilco 2008-01-03 20:49:10 UTC
GeoClue needs wireless LAN information if GPS is not available.  It looks like
at present LibConIC can only report the current WLAN/WiFi connection.  It would
be helpful if when there is no active WLAN connection for there to be a
LibConIC request to return some list of wireless hub descriptions (their
broadcast IDs as a minumum; signal strength is optional).  The automatic
connection to wireless base stations requires periodic listening to WLAN info
and a cache of ID info needs to be passed along; LibConIC seems to be the
interface for the device with the info.

At the application level, the last GPS reading or a WLAN ID database can
identify the current location of the WLAN service.  This will allow location
awareness indoors, such as when walking around an enclosed shopping center. 
N800 allows Internet connectivity in such situations but location hints are not
available.  Discussion about N800 Kismet indicates there are problems with that
application's device-level interface.  WLAN ID info is already being processed
by the N800 tools.
Comment 7 SEWilco 2008-01-04 19:23:48 UTC
(In reply to comment #6)
> GeoClue needs wireless LAN information if GPS is not available.  It looks like
> at present LibConIC can only report the current WLAN/WiFi connection.  It would
> be helpful if when there is no active WLAN connection for there to be a
> LibConIC request to return some list of wireless hub descriptions (their
> broadcast IDs as a minumum; signal strength is optional).  If the automatic
> connection to wireless base stations requires periodic listening to WLAN info
> then a cache of ID info needs to be passed along; LibConIC seems to be the
> interface for the device with the info.
> 
> At the application level, the last GPS reading or a WLAN ID database can
> identify the current location of the WLAN service.  This will allow location
> awareness indoors, such as when walking around an enclosed shopping center. 
> N800 allows Internet connectivity in such situations but location hints are not
> available.  Discussion about N800 Kismet indicates there are problems with that
> application's device-level interface.
>
Comment 8 Jussi Kukkonen 2008-01-08 22:31:12 UTC
(In reply to comment #6)
> GeoClue needs wireless LAN information if GPS is not available.  

The geoclue mailing list (see http://geoclue.freedesktop.org) is a better place
for geoclue feature discussion -- all requests and ideas are welcome.

 A note on your idea: There is a Geoclue position provider that uses WLAN APs
to get the position already: plazes-provider uses plazes.com web service to
locate the AP. It's not perfect: a free AP location database would be better
but that does not exist at the moment (wigle.net requires logging in,
unfortunately).

Further discussion on this should probably happen on the mailing list.
Comment 9 Quim Gil nokia 2008-09-30 12:05:22 UTC
The whole location framework will see significant improvements but GeoClue is
not in the plans. In fact Nokia as a whole is making big investments in own
location technologies and services covering the whole stack. In this context
GeoClue has little to no chances to be officially supported, at least at this
point.